%%
%% Matlab Test Code - Side-Channel Statistical Toolbox
%% Copyright  Franois-Xavier Standaert
%% e-mail: <fstandae@uclouvain.be>
%%
%% This program is a free software: you can redistribute it 
%% and/or modify it under the terms of the GNU General Public 
%% License as published by the Free Software Foundation.
%%
%% It is distributed without any warranty of correctness nor
%% fintess for any particular purpose. See the GNU General 
%% Public License for more details.
%% 
%% <http://www.gnu.org/licenses/>
%%
%% Description: vector of "close Hamming weight" for a given Wh
%% 
%% Version 1 - February 2015

function BHC=best_Wy_candidates(Wy,n)

for cand=0:2^n-1
    hc=hamming(cand,n);
    hd(cand+1)=abs(hc-Wy);
end

[temp,BVC]=sort(hd,'ascend');

for i=0:2^n-1
    BHC(i+1)=hamming(BVC(i+1)-1,n);
end
