%%
%% Matlab Test Code - Side-Channel Statistical Toolbox
%% Copyright  Franois-Xavier Standaert
%% e-mail: <fstandae@uclouvain.be>
%%
%% This program is a free software: you can redistribute it 
%% and/or modify it under the terms of the GNU General Public 
%% License as published by the Free Software Foundation.
%%
%% It is distributed without any warranty of correctness nor
%% fintess for any particular purpose. See the GNU General 
%% Public License for more details.
%% 
%% <http://www.gnu.org/licenses/>
%%
%% Description: logarithmic combination from Poussier et al. (CARDIS 2015)
%% 
%% Version 1 - Januray 2016


function [Xc,SRc]=comb_log(Xa,SRa,Xb,SRb)
    
N1=size(SRa,2);
N2=size(SRb,2);

Xc=zeros(1,N1+N2-1)-1;
SRc=zeros(1,N1+N2-1)-1;
for i=1:N1
    for j=1:N2
        temp=SRa(i)*SRb(j);
        if temp>SRc(i+j-1)
            SRc(i+j-1)=temp;
            Xc(i+j-1)=Xa(i)+Xb(j);
        end
    end
end